// json5.js
// Modern JSON. See README.md for details.
//
// This file is based directly off of Douglas Crockford's json_parse.js:
// https://github.com/douglascrockford/JSON-js/blob/master/json_parse.js

var JSON5=typeof exports==="object"?exports:{};JSON5.parse=function(){"use strict";var at,ch,escapee={"'":"'",'"':'"',"\\":"\\","/":"/","\n":"",b:"\b",f:"\f",n:"\n",r:"\r",t:"	"},text,error=function(m){var error=new SyntaxError;error.message=m;error.at=at;error.text=text;throw error},next=function(c){if(c&&c!==ch){error("Expected '"+c+"' instead of '"+ch+"'")}ch=text.charAt(at);at+=1;return ch},identifier=function(){var key=ch;if(ch!=="_"&&ch!=="$"&&(ch<"a"||ch>"z")&&(ch<"A"||ch>"Z")){error("Bad identifier")}while(next()&&(ch==="_"||ch==="$"||ch>="a"&&ch<="z"||ch>="A"&&ch<="Z"||ch>="0"&&ch<="9")){key+=ch}return key},number=function(){var number,sign="",string="",base=10;if(ch==="-"||ch==="+"){sign=string=ch;next(ch)}if(ch==="I"){number=word();if(typeof number!=="number"||isNaN(number)){error("Unexpected word for number")}return sign==="-"?-number:number}if(ch==="0"){string+=ch;next();if(ch==="x"||ch==="X"){string+=ch;next();base=16}else if(ch>="0"&&ch<="9"){error("Octal literal")}}if(base===16&&sign){error("Signed hexadecimal literal")}switch(base){case 10:while(ch>="0"&&ch<="9"){string+=ch;next()}if(ch==="."){string+=".";while(next()&&ch>="0"&&ch<="9"){string+=ch}}if(ch==="e"||ch==="E"){string+=ch;next();if(ch==="-"||ch==="+"){string+=ch;next()}while(ch>="0"&&ch<="9"){string+=ch;next()}}break;case 16:while(ch>="0"&&ch<="9"||ch>="A"&&ch<="F"||ch>="a"&&ch<="f"){string+=ch;next()}break}number=+string;if(!isFinite(number)){error("Bad number")}else{return number}},string=function(){var hex,i,string="",delim,uffff;if(ch==='"'||ch==="'"){delim=ch;while(next()){if(ch===delim){next();return string}else if(ch==="\\"){next();if(ch==="u"){uffff=0;for(i=0;i<4;i+=1){hex=parseInt(next(),16);if(!isFinite(hex)){break}uffff=uffff*16+hex}string+=String.fromCharCode(uffff)}else if(typeof escapee[ch]==="string"){string+=escapee[ch]}else{break}}else if(ch==="\n"){break}else{string+=ch}}}error("Bad string")},inlineComment=function(){if(ch!=="/"){error("Not an inline comment")}do{next();if(ch==="\n"){next("\n");return}}while(ch)},blockComment=function(){if(ch!=="*"){error("Not a block comment")}do{next();while(ch==="*"){next("*");if(ch==="/"){next("/");return}}}while(ch);error("Unterminated block comment")},comment=function(){if(ch!=="/"){error("Not a comment")}next("/");if(ch==="/"){inlineComment()}else if(ch==="*"){blockComment()}else{error("Unrecognized comment")}},white=function(){while(ch){if(ch==="/"){comment()}else if(ch<=" "){next()}else{return}}},word=function(){switch(ch){case"t":next("t");next("r");next("u");next("e");return true;case"f":next("f");next("a");next("l");next("s");next("e");return false;case"n":next("n");next("u");next("l");next("l");return null;case"I":next("I");next("n");next("f");next("i");next("n");next("i");next("t");next("y");return Infinity}error("Unexpected '"+ch+"'")},value,array=function(){var array=[];if(ch==="["){next("[");white();while(ch){if(ch==="]"){next("]");return array}if(ch===","){error("Missing array element")}else{array.push(value())}white();if(ch!==","){next("]");return array}next(",");white()}}error("Bad array")},object=function(){var key,object={};if(ch==="{"){next("{");white();while(ch){if(ch==="}"){next("}");return object}if(ch==='"'||ch==="'"){key=string()}else{key=identifier()}white();next(":");if(Object.hasOwnProperty.call(object,key)){error('Duplicate key "'+key+'"')}object[key]=value();white();if(ch!==","){next("}");return object}next(",");white()}}error("Bad object")};value=function(){white();switch(ch){case"{":return object();case"[":return array();case'"':case"'":return string();case"-":case"+":case".":return number();default:return ch>="0"&&ch<="9"?number():word()}};return function(source,reviver){var result;text=source;at=0;ch=" ";result=value();white();if(ch){error("Syntax error")}return typeof reviver==="function"?function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==="object"){for(k in value){if(Object.prototype.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!==undefined){value[k]=v}else{delete value[k]}}}}return reviver.call(holder,key,value)}({"":result},""):result}}();JSON5.stringify=function(obj,replacer,space){if(replacer){throw new Error("JSON5 does not support the replacer parameter. Use JSON instead.")}function isWordChar(char){return char>="a"&&char<="z"||char>="A"&&char<="Z"||char>="0"&&char<="9"||char==="_"||char==="$"}function isWordStart(char){return char>="a"&&char<="z"||char>="A"&&char<="Z"||char==="_"||char==="$"}function isWord(key){if(typeof key!=="string"){return false}if(!isWordStart(key[0])){return false}var i=1,length=key.length;while(i<length){if(!isWordChar(key[i])){return false}i++}return true}JSON5.isWord=isWord;function isArray(obj){if(Array.isArray){return Array.isArray(obj)}else{return Object.prototype.toString.call(obj)==="[object Array]"}}function isDate(obj){return Object.prototype.toString.call(obj)==="[object Date]"}isNaN=isNaN||function(val){return typeof val==="number"&&val!==val};var objStack=[];function checkForCircular(obj){for(var i=0;i<objStack.length;i++){if(objStack[i]===obj){throw new TypeError("Converting circular structure to JSON")}}}function makeIndent(str,num,noNewLine){if(!str){return""}if(str.length>10){str=str.substring(0,10)}var indent=noNewLine?"":"\n";for(var i=0;i<num;i++){indent+=str}return indent}var indentStr;if(space){if(typeof space==="string"){indentStr=space}else if(typeof space==="number"&&space>=0){indentStr=makeIndent(" ",space,true)}else{}}var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,meta={"\b":"\\b","	":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};function escapeString(string){escapable.lastIndex=0;return escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return typeof c==="string"?c:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+string+'"'}function internalStringify(obj_part){var buffer,res;if(obj_part&&!isDate(obj_part)){obj_part=obj_part.valueOf()}switch(typeof obj_part){case"boolean":return obj_part.toString();case"number":if(isNaN(obj_part)||!isFinite(obj_part)){return"null"}return obj_part.toString();case"string":return escapeString(obj_part.toString());case"object":if(obj_part===null){return"null"}else if(isDate(obj_part)){return escapeString(obj_part.toJSON())}else if(isArray(obj_part)){checkForCircular(obj_part);buffer="[";objStack.push(obj_part);for(var i=0;i<obj_part.length;i++){res=internalStringify(obj_part[i]);buffer+=makeIndent(indentStr,objStack.length);if(res===null||typeof res==="undefined"){buffer+="null"}else{buffer+=res}if(i<obj_part.length-1){buffer+=","}else if(indentStr){buffer+="\n"}}objStack.pop();buffer+=makeIndent(indentStr,objStack.length,true)+"]"}else{checkForCircular(obj_part);buffer="{";var nonEmpty=false;objStack.push(obj_part);for(var prop in obj_part){if(obj_part.hasOwnProperty(prop)){var value=internalStringify(obj_part[prop]);if(typeof value!=="undefined"&&value!==null){buffer+=makeIndent(indentStr,objStack.length);nonEmpty=true;var key=isWord(prop)?prop:escapeString(prop);buffer+=key+":"+(indentStr?" ":"")+value+","}}}objStack.pop();if(nonEmpty){buffer=buffer.substring(0,buffer.length-1)+makeIndent(indentStr,objStack.length)+"}"}else{buffer="{}"}}return buffer;default:return undefined}}if(obj===undefined){return undefined}return internalStringify(obj,replacer,space)};